#include <u.h>
#include <libc.h>
#include <stdio.h>
#include <ctype.h>  // isalpha()

#include "psgen.h"

void main(void) {
	PSDoc *ps;
	int pspattern1, pspattern2;
double llx, lly, urx, ury;
char pat_name[128];
char epsfile[128];

	// initialize
	ps = PS_new();

	if (0 > PS_open_file(ps, "draw.ps")) {
		printf("Cannot open PostScript file\n");
		exits("Cannot open PostScript file");
	}

	// define pattern1
	pspattern1 = PS_begin_pattern(ps, 10.0, 10.0, 10.0, 10.0, 1);
	PS_setcolor(ps, "both", "gray", 0.0, 0.0, 0.0, 0.0);
	PS_moveto(ps, 0, 0);
	PS_lineto(ps, 7, 7);
	PS_stroke(ps);
	PS_moveto(ps, 0, 7);
	PS_lineto(ps, 7, 0);
	PS_stroke(ps);
	PS_end_pattern(ps);

	// define pattern2
strcpy(pat_name, "brick");
strcat(epsfile, "../patterns/");
strcat(epsfile, pat_name);
strcat(epsfile, ".eps");


	eps_bbox(epsfile, &llx, &lly, &urx, &ury);
	pspattern2 = PS_begin_pattern(ps, urx, ury, urx, ury, 1);
	PS_setcolor(ps, "both", "gray", 0.0, 0.0, 0.0, 0.0);
	pat_save(ps, epsfile, pat_name);
	PS_end_pattern(ps);


	// generate page
	PS_begin_page(ps, 596, 842);


	// draw a box filled with brown color
	PS_setcolor(ps, "fill", "rgb", 0.6, 0.5, 0.4, 0.0);
	PS_rect(ps, 50, 50, 35, 35);
	PS_fill(ps);

	// add pattern
	PS_setcolor(ps, "fill", "pattern", (float) pspattern2, 0.0, 0.0, 0.0);
	PS_rect(ps, 50, 50, 35, 35);
	PS_fill(ps);

	// draw arc 
	PS_setcolor(ps, "fill", "rgb", 0.6, 0.5, 0.4, 0.0);
	PS_arc(ps, 50, 150, 35, 0, 270);
	PS_fill(ps);

	// add pattern
	PS_setcolor(ps, "fill", "pattern", (float) pspattern1, 0.0, 0.0, 0.0);
	PS_arc(ps, 50, 150, 35, 0, 270);
	PS_fill(ps);


	// close all and exit
	PS_end_page(ps);
	PS_close(ps);
	PS_delete(ps);
	PS_shutdown();
//	exits(0);
}
