#include <u.h>
#include <libc.h>
#include <stdio.h>
#include <ctype.h>  // isalpha()

#include "psgen.h"

//////////////////////////////////////////////////////////////
/*  test if file is realy EPS file and find bbox 
 *  returns  1 if OK
 *           0 on error               
 */
int eps_bbox(char *eps, double *llx, double *lly, double *urx, double *ury)
{
    char buf[201];
    FILE *fp;
    int v1, v2, v3, v4;

    /* test if file is realy eps and find bbox */
    if ((fp = fopen(eps, "r")) == NULL) {
	fprintf(stderr, "can't open eps file <%s>\n", eps);
	return (0);
    }
    /* test if first row contains '%!PS-Adobe-m.n EPSF-m.n' string */
    fgets(buf, 200, fp);
    if (sscanf(buf, "%%!PS-Adobe-%d.%d EPSF-%d.%d", &v1, &v2, &v3, &v4) < 4) {
	fprintf(stderr, "file <%s> is not in EPS format\n", eps);
	fclose(fp);
	return (0);
    }
    /* looking for bbox */
    while (fgets(buf, 200, fp) != NULL) {
	if (sscanf
	    (buf, "%%%%BoundingBox: %lf %lf %lf %lf", llx, lly, urx,
	     ury) == 4) {
	    fclose(fp);
	    return (1);
	}
    }
    fprintf(stderr, "Bounding box in eps file <%s> was not found\n", eps);
    fclose(fp);
    return (0);
}



/* save EPS pattern file into PS file for later use */
/* For pattern we have to remove header comments */
int pat_save(PSDoc *psdoc, char *epsf, char *name)
{
    char buf[1024];
    FILE *epsfp;

    if ((epsfp = fopen(epsf, "r")) == NULL)
	return (0);


//   ps_printf(psdoc, "\n/%s {\n", name);
    while (fgets(buf, 1024, epsfp) != NULL) {
	if (strncmp(buf, "%!PS-Adobe", 10) == 0 || strncmp(buf, "%%BoundingBox", 13) == 0) 
          continue;  // read next line
	    
	ps_printf(psdoc, "%s", buf);
    }
//    ps_printf(psdoc, "} def\n");
    fclose(epsfp);

    return (1);
}

//////////////////////////////////////////////////////////////


