/* LibHnj is dual licensed under LGPL and MPL */

/* wrappers for malloc */

#include <u.h>
#include <libc.h>
#include <stdio.h>

void *
hnj_malloc (int size)
{
  void *p;

  p = malloc (size);
  if (p == NULL)
    {
      fprintf (stderr, "can't allocate %d bytes\n", size);
      exits ("can't allocate memory");
    }
  return p;
}

void *
hnj_realloc (void *p, int size)
{
  p = realloc (p, size);
  if (p == NULL)
    {
      fprintf (stderr, "can't allocate %d bytes\n", size);
      exits ("can't allocate memory");
    }
  return p;
}

void
hnj_free (void *p)
{
  free (p);
}

