#define TRUE 1
#define FALSE 0

#define PS_MemoryError 1
#define PS_IOError 2
#define PS_RuntimeError 3
#define PS_Warning 100

#define PS_LINECAP_BUTT 0
#define PS_LINECAP_ROUND 1
#define PS_LINECAP_SQUARED 2

#define PS_LINEJOIN_MITER 0
#define PS_LINEJOIN_ROUND 1
#define PS_LINEJOIN_BEVEL 2

#define PS_GOTO_NEXT_PAGE -1
#define PS_GOTO_PREV_PAGE -2

#define ps_true 1
#define ps_false 0

typedef int ps_bool;
typedef struct PSDoc_ PSDoc;

int
PS_get_majorversion(void);

int
PS_get_minorversion(void);

int
PS_get_subminorversion(void);

void
PS_boot(void);

void
PS_shutdown(void);

void
PS_set_info(PSDoc *p, const char *key, const char *val);

PSDoc *
PS_new(void);

PSDoc *
PS_new2(void  (*errorhandler)(PSDoc *p, int type, const char *msg, void *data),
	void* (*allocproc)(PSDoc *p, ulong size, const char *caller),
	void* (*reallocproc)(PSDoc *p, void *mem, ulong size, const char *caller),
	void  (*freeproc)(PSDoc *p, void *mem),
	void *opaque);

int
PS_open_fp(PSDoc *psdoc, FILE *fp);

void *
PS_get_opaque(PSDoc *psdoc);

int
PS_open_mem(PSDoc *p, ulong (*writeproc)(PSDoc *p, void *data, ulong size));

int
PS_open_file(PSDoc *psdoc, const char *filename);

void
PS_close(PSDoc *psdoc);

void
PS_delete(PSDoc *psdoc);

void
PS_begin_page(PSDoc *psdoc, float width, float height);

void
PS_end_page(PSDoc *psdoc);

void
PS_set_parameter(PSDoc *psdoc, const char *name, const char *value);

const char *
PS_get_parameter(PSDoc *psdoc, const char *name, float modifier);

void
PS_set_value(PSDoc *psdoc, const char *name, float value);

float
PS_get_value(PSDoc *psdoc, const char *name, float modifier);

void
PS_list_values(PSDoc *psdoc);

void
PS_list_parameters(PSDoc *psdoc);

void
PS_list_resources(PSDoc *psdoc);

void
PS_set_text_pos(PSDoc *psdoc, float x, float y);

void
PS_setlinewidth(PSDoc *p, float width);

void
PS_setlinecap(PSDoc *p, int type);

void
PS_setlinejoin(PSDoc *p, int type);

void
PS_setmiterlimit(PSDoc *p, float value);

void
PS_setflat(PSDoc *p, float value);

void
PS_setoverprintmode(PSDoc *p, int mode);

void
PS_setsmoothness(PSDoc *p, float smoothness);

void
PS_setdash(PSDoc *p, float on, float off);

void
PS_setpolydash(PSDoc *p, float *arr, int length);

void
PS_curveto(PSDoc *psdoc, float x1, float y1, float x2, float y2, float x3, float y3);

void
PS_rect(PSDoc *psdoc, float x, float y, float width, float height);

void
PS_circle(PSDoc *psdoc, float x, float y, float radius);

void
PS_arc(PSDoc *psdoc, float x, float y, float radius, float alpha, float beta);

void
PS_arcn(PSDoc *psdoc, float x, float y, float radius, float alpha, float beta);

void
PS_clip(PSDoc *psdoc);

void
PS_setgray(PSDoc *psdoc, float gray);

void
PS_closepath(PSDoc *psdoc);

void
PS_closepath_stroke(PSDoc *psdoc);

void
PS_fill_stroke(PSDoc *psdoc);

void
PS_stroke(PSDoc *psdoc);

void
PS_fill(PSDoc *psdoc);

void
PS_save(PSDoc *psdoc);

void
PS_restore(PSDoc *psdoc);

void
PS_show(PSDoc *psdoc, const char *text);

void
PS_show2(PSDoc *psdoc, const char *text, int xlen);

void
PS_show_xy(PSDoc *psdoc, const char *text, float x, float y);

void
PS_show_xy2(PSDoc *psdoc, const char *text, int xlen, float x, float y);

int
PS_show_boxed(PSDoc *psdoc, const char *text, float left, float bottom, float width, float height, const char *hmode, const char *feature);

void
PS_continue_text(PSDoc *psdoc, const char *text);

void
PS_continue_text2(PSDoc *psdoc, const char *text, int len);

void
PS_setcolor(PSDoc *psdoc, const char *type, const char *colorspace, float c1, float c2, float c3, float c4);

int
PS_makespotcolor(PSDoc *psdoc, const char *name, int reserved);

int
PS_findfont(PSDoc *psdoc, const char *fontname, const char *encoding, int embed);

float
PS_stringwidth(PSDoc *psdoc, const char *text, int fontid, float size);

float
PS_stringwidth2(PSDoc *psdoc, const char *text, int xlen, int fontid, float size);

float
PS_string_geometry(PSDoc *psdoc, const char *text, int xlen, int fontid, float size, float *dimension);

void
PS_deletefont(PSDoc *psdoc, int fontid);

void
PS_setfont(PSDoc *psdoc, int fontid, float size);

int
PS_getfont(PSDoc *psdoc);

void
PS_moveto(PSDoc *psdoc, float x, float y);

void
PS_lineto(PSDoc *psdoc, float x, float y);

void
PS_rotate(PSDoc *psdoc, float x);

void
PS_translate(PSDoc *psdoc, float x, float y);

void
PS_scale(PSDoc *psdoc, float x, float y);

const char *
PS_get_buffer(PSDoc *psdoc, long *size);

int
PS_open_image(PSDoc *psdoc, const char *type, const char *source, const char *data, long length, int width, int height, int components, int bpc, const char *params);

int
PS_open_image_file(PSDoc *psdoc, const char *type, const char *filename, const char *stringparam, int intparam);

void
PS_place_image(PSDoc *psdoc, int imageid, float x, float y, float scale);

void
PS_close_image(PSDoc *psdoc, int imageid);

void
PS_add_weblink(PSDoc *psdoc, float llx, float lly, float urx, float ury, const char *url);

void
PS_add_pdflink(PSDoc *psdoc, float llx, float lly, float urx, float ury, const char *filename, int page, const char *dest);

void
PS_add_locallink(PSDoc *psdoc, float llx, float lly, float urx, float ury, const int page, const char *dest);

void
PS_add_launchlink(PSDoc *psdoc, float llx, float lly, float urx, float ury, const char *filename);

int
PS_add_bookmark(PSDoc *psdoc, const char *text, int parent, int open);

void
PS_add_note(PSDoc *psdoc, float llx, float lly, float urx, float ury, const char *contents, const char *title, const char *icon, int open);

void
PS_set_border_style(PSDoc *psdoc, const char *style, float width);

void
PS_set_border_color(PSDoc *psdoc, float red, float green, float blue);

void
PS_set_border_dash(PSDoc *psdoc, float black, float white);

int
PS_begin_template(PSDoc *psdoc, float width, float height);

void
PS_end_template(PSDoc *psdoc);

int
PS_begin_pattern(PSDoc *psdoc, float width, float height, float xstep, float ystep, int painttype);

void
PS_end_pattern(PSDoc *psdoc);

void
PS_shfill(PSDoc *psdoc, int shading);

int
PS_shading(PSDoc *psdoc, const char *shtype, float x0, float y0, float x1, float y1, float c1, float c2, float c3, float c4, const char *optlist);

int
PS_shading_pattern(PSDoc *psdoc, int shading, const char *optlist);

int
PS_create_gstate(PSDoc *psdoc, const char *optlist);

int
PS_hyphenate(PSDoc *psdoc, const char *text, char **hyphens);

void
PS_symbol(PSDoc *psdoc, uchar c);

float
PS_symbol_width(PSDoc *psdoc, uchar c, int fontid, float size);

void
PS_symbol_name(PSDoc *psdoc, uchar c, int fontid, char *name, int size);

int
PS_include_file(PSDoc *psdoc, const char *filename);

int
PS_begin_font(PSDoc *psdoc, const char *fontname, int reserverd, double a, double b, double c, double d, double e, double f, const char *optlist);

void
PS_end_font(PSDoc *psdoc);

int
PS_begin_glyph(PSDoc *psdoc, const char *glyphname, double wx, double llx, double lly, double urx, double ury);

void
PS_end_glyph(PSDoc *psdoc);

void
PS_add_kerning(PSDoc *psdoc, int fontid, const char *glyphname1, const char *glyphname2, int kern);

void
PS_add_ligature(PSDoc *psdoc, int fontid, const char *glyphname1, const char *glyphname2, const char *glyphname3);

void
PS_glyph_show(PSDoc *psdoc, const char *name);

char**
PS_glyph_list(PSDoc *psdoc, int fontid, char ***charlist, int *len);

float
PS_glyph_width(PSDoc *psdoc, const char *glyphname, int fontid, float size);

void
PS_free_glyph_list(PSDoc *psdoc, char **charlist, int len);

/*********************************************************************
 * Copyright (C) 2001, 2003-2004-2002,  Simon Kagstrom
 *
 * Filename:      ght_hash_table.h.in
 * Description:   The definitions used in the hash table.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: ght_hash_table.h.in,v 1.4 2007/07/04 13:07:59 steinm Exp $
 *
 ********************************************************************/

/**
 * @file
 * libghthash is a generic hash table used for storing arbitrary
 * data.
 *
 * Libghthash really stores pointers to data - the hash
 * table knows nothing about the actual type of the data.
 *
 * A simple example to get started can be found in the
 * <TT>example/simple.c</TT> file found in the distribution.
 * <TT>hash_test.c</TT> provides a more comlpete example.
 *
 * Some basic properties of the hash table are:
 *
 * - Both the data stored and the keys are of void type, which
 *   means that you can store any kind of data.
 *
 * - The only functions you probably will need to start is:
 *   - ght_create(), which creates a new hash table.d
 *   - ght_insert(), which inserts a new entry into a table.
 *   - ght_get(), which searches for an entry.
 *   - ght_remove(), which removes and entry.
 *   - ght_finalize(), which destroys a hash table.
 *
 * - Inserting entries is done without first creating a key,
 *   i.e. you insert with the data, the datasize, the key and the
 *   key size directly.
 *
 * - The hash table copies the key data when inserting new
 *   entries. This means that you should <I>not</I> malloc() the key
 *   before inserting a new entry.
 *
 */

#define GHT_HEURISTICS_NONE          0
#define GHT_HEURISTICS_TRANSPOSE     1
#define GHT_HEURISTICS_MOVE_TO_FRONT 2
#define GHT_AUTOMATIC_REHASH         4


/**
 * The structure for hash keys. You should not care about this
 * structure unless you plan to write your own hash functions.
 */
typedef struct s_hash_key
{
  uint i_size;       /**< The size in bytes of the key p_key */
  void *p_key;               /**< A pointer to the key. */
} ght_hash_key_t;

/*
 * The structure for hash entries.
 */
typedef struct s_hash_entry
{
  void *p_data;

  struct s_hash_entry *p_next;
  struct s_hash_entry *p_prev;
  ght_hash_key_t key;
} ght_hash_entry_t;

/*
 * The structure used in iterations. You should not care about the
 * contents of this, it will be filled and updated by ght_first() and
  * ght_next().
 */
typedef struct
{
  int i_curr_bucket;         /* The current bucket */
  ght_hash_entry_t *p_entry; /* The current entry */
  ght_hash_entry_t *p_next;  /* The next entry */
} ght_iterator_t;

/**
 * Definition of the hash function pointers. @c ght_fn_hash_t should be
 * used when implementing new hash functions. Look at the supplied
 * hash functions, like @c ght_one_at_a_time_hash(), for examples of hash
 * functions.
 *
 * @param p_key the key to calculate the hash value for.
 *
 * @return a 32 bit hash value.
 *
 * @see @c ght_one_at_a_time_hash(), @c ght_rotating_hash(),
 *      @c ght_crc_hash()
 */
typedef uint (*ght_fn_hash_t)(ght_hash_key_t *p_key);

/**
 * Definition of the allocation function pointers. This is simply the
 * same definition as @c malloc().
 *
 * @param size the size to allocate. This will always be
 *        <TT>sizeof(ght_hash_entry_t) + sizeof(ght_hash_key_t) +
 *        key_size</TT>.
 *
 * @return a pointer to the allocated region, or NULL if the
 *         allocation failed.
 */
typedef void *(*ght_fn_alloc_t)(ulong size, void *data);

/**
 * Definition of the deallocation function pointers. This is simply the
 * same definition as @c free().
 *
 * @param ptr a pointer to the region to free.
 */
typedef void (*ght_fn_free_t)(void *ptr, void *data);


/**
 * The hash table structure.
 */
typedef struct
{
  uint i_items;              /**< The current number of items in the table */
  uint i_size;               /**< The number of buckets */
  ght_fn_hash_t fn_hash;             /**< The hash function used */
  ght_fn_alloc_t fn_alloc;           /**< The function used for allocating entries */
  ght_fn_free_t fn_free;             /**< The function used for freeing entries */
	void *userdata;                    /**< User data passed to alloc and free */
  int i_heuristics;                  /**< The type of heuristics used */
  int i_automatic_rehash;            /**< TRUE if automatic rehashing is used */

  /* private: */
  ght_hash_entry_t **pp_entries;
  int *p_nr;                         /* The number of entries in each bucket */
  int i_size_mask;                   /* The number of bits used in the size */
} ght_hash_table_t;

/**
 * Create a new hash table. The number of buckets should be about as
 * big as the number of elements you wish to store in the table for
 * good performance. The number of buckets is rounded to the next
 * higher power of two.
 *
 * The hash table is created with @c ght_one_at_a_time_hash() as hash
 * function, automatic rehashing disabled, @c malloc() as the memory
 * allocator and no heuristics.
 *
 * @param i_size the number of buckets in the hash table. Giving a
 *        non-power of two here will round the size up to the next
 *        power of two.
 *
 * @see ght_one_at_a_time_hash(), ght_rotating_hash(), ght_crc_hash(),
 * @see ght_set_heuristics(), ght_set_rehash()
 *
 * @return a pointer to the hash table or NULL upon error.
 */
ght_hash_table_t *ght_create(uint i_size);

/**
 * Set the allocation/freeing functions to use for a hash table. The
 * allocation function will only be called when a new entry is
 * inserted.
 *
 * The allocation size will always be <TT>sizeof(ght_hash_entry_t) +
 * sizeof(ght_hash_key_t) + key_size</TT>. The actual size varies with
 * the key size.
 *
 * If this function is <I>not</I> called, @c malloc() and @c free()
 * will be used for allocation and freeing.
 *
 * @warning Always call this function <I>before</I> any entries are
 *          inserted into the table. Otherwise, the new free() might be called
 *          on something that were allocated with another allocation function.
 *
 * @param p_ht the hash table to set the memory management functions
 *        for.
 * @param fn_alloc the allocation function to use.
 * @param fn_free the deallocation function to use.
 */
void ght_set_alloc(ght_hash_table_t *p_ht, ght_fn_alloc_t fn_alloc, ght_fn_free_t fn_free, void* data);

/**
 * Set the hash function to use for a hash table.
 *
 * @warning Always call this function before any entries are inserted
 *          into the table. Otherwise, it will not be possible to find entries
 *          that were inserted before this function was called.
 *
 * @param p_ht the hash table set the hash function for.
 * @param fn_hash the hash function.
 */
void ght_set_hash(ght_hash_table_t *p_ht, ght_fn_hash_t fn_hash);

/**
 * Set the heuristics to use for the hash table. The possible values are:
 *
 * - <TT>GHT_HEURISTICS_NONE</TT>: Don't use any heuristics.
 * - <TT>0</TT>: Same as above.
 * - <TT>GHT_HEURISTICS_TRANSPOSE</TT>: Use transposing heuristics. An
 *   accessed element will move one step up in the bucket-list with this
 *   method.
 * - <TT>GHT_HEURISTICS_MOVE_TO_FRONT</TT>: Use move-to-front
 *   heuristics. An accessed element will be moved the front of the
 *   bucket list with this method.
 *
 * @param p_ht the hash table set the heuristics for.
 * @param i_heuristics the heuristics to use.
 */
void ght_set_heuristics(ght_hash_table_t *p_ht, int i_heuristics);

/**
 * Enable or disable automatic rehashing.
 *
 * With automatic rehashing, the table will rehash itself when the
 * number of elements in the table are twice as many as the number of
 * buckets. You should note that automatic rehashing will cause your
 * application to be really slow when the table is rehashing (which
 * might happen at times when you need speed), you should therefore be
 * careful with this in time-constrainted applications.
 *
 * @param p_ht the hash table to set rehashing for.
 * @param b_rehash TRUE if rehashing should be used or FALSE if it
 *        should not be used.
 */
void ght_set_rehash(ght_hash_table_t *p_ht, int b_rehash);

/**
 * Get the size (the number of items) of the hash table.
 *
 * @param p_ht the hash table to get the size for.
 *
 * @return the number of items in the hash table.
 */
uint ght_size(ght_hash_table_t *p_ht);

/**
 * Get the table size (the number of buckets) of the hash table.
 *
 * @param p_ht the hash table to get the table size for.
 *
 * @return the number of buckets in the hash table.
 */
uint ght_table_size(ght_hash_table_t *p_ht);


/**
 * Insert an entry into the hash table. Prior to inserting anything,
 * make sure that the table is created with ght_create(). If an
 * element with the same key as this one already exists in the table,
 * the insertion will fail and -1 is returned.
 *
 * A typical example is shown below, where the string "blabla" is used
 * as a key for the integer 15.
 *
 * ght_hash_table_t *p_table;
 * char *p_key_data;
 * int *p_data;
 * int ret;
 *
 * [Create p_table etc...]
 * p_data = malloc(sizeof(int));
 * p_key_data = "blabla";
 * *p_data = 15;
 *
 * ret = ght_insert(p_table,
 *                  p_data,
 *                  sizeof(char)*strlen(p_key_data), p_key_data);
 *
 * @param p_ht the hash table to insert into.
 * @param p_entry_data the data to insert.
 * @param i_key_size the size of the key to associate the data with (in bytes).
 * @param p_key_data the key to use. The value will be copied, and it
 *                   is therefore OK to use a stack-allocated entry here.
 *
 * @return 0 if the element could be inserted, -1 otherwise.
 */
int ght_insert(ght_hash_table_t *p_ht,
	       void *p_entry_data,
	       uint i_key_size, void *p_key_data);

/**
 * Replace an entry in the hash table. This function will return an
 * error if the entry to be replaced does not exist, i.e. it cannot be
 * used to insert new entries.
 *
 * @param p_ht the hash table to search in.
 * @param p_entry_data the new data for the key.
 * @param i_key_size the size of the key to search with (in bytes).
 * @param p_key_data the key to search for.
 *
 * @return a pointer to the <I>old</I> value or NULL if the operation failed.
 */
void *ght_replace(ght_hash_table_t *p_ht,
		  void *p_entry_data,
		  uint i_key_size, void *p_key_data);


/**
 * Lookup an entry in the hash table. The entry is <I>not</I> removed from
 * the table.
 *
 * @param p_ht the hash table to search in.
 * @param i_key_size the size of the key to search with (in bytes).
 * @param p_key_data the key to search for.
 *
 * @return a pointer to the found entry or NULL if no entry could be found.
 */
void *ght_get(ght_hash_table_t *p_ht,
	      uint i_key_size, void *p_key_data);

/**
 * Remove an entry from the hash table. The entry is removed from the
 * table, but not freed (that is, the data stored is not freed).
 *
 * @param p_ht the hash table to use.
 * @param i_key_size the size of the key to search with (in bytes).
 * @param p_key_data the key to search for.
 *
 * @return a pointer to the removed entry or NULL if the entry could be found.
 */
void *ght_remove(ght_hash_table_t *p_ht,
		 uint i_key_size, void *p_key_data);

/**
 * Return the first entry in the hash table. This function should be
 * used for iteration and is used together with ght_next(). Note that
 * you cannot assume anything about the order in which the entries are
 * accessed. If an entry is inserted during an iteration, the entry
 * might or might not occur in the iteration.
 *
 * The use of the ght_iterator_t allows for several concurrent
 * iterations, where you would use one ght_iterator_t for each
 * iteration. In threaded environments, you should still lock access
 * to the hash table for insertion and removal.
 *
 * A typical example might look as follows:
 * <PRE>
 * ght_hash_table_t *p_table;
 * ght_iterator_t iterator;
 * void *p_key;
 * void *p_e;
 *
 * [Create table etc...]
 * for(p_e = ght_first(p_table, &iterator, &p_key); p_e; p_e = ght_next(p_table, &iterator, &p_key))
 *   {
 *      [Do something with the current entry p_e and it's key p_key]
 *   }
 * </PRE>
 *
 * @param p_ht the hash table to iterate through.
 *
 * @param p_iterator the iterator to use. The value of the structure
 * is filled in by this function and may be stack allocated.
 *
 * @param pp_key a pointer to the pointer of the key (NULL if none).
 *
 * @return a pointer to the first entry in the table or NULL if there
 * are no entries.
 *
 *
 * @see ght_next()
 */
void *ght_first(ght_hash_table_t *p_ht, ght_iterator_t *p_iterator, void **pp_key);

/**
 * Return the next entry in the hash table. This function should be
 * used for iteration, and must be called after ght_first().
 *
 * @warning calling this without first having called ght_first will
 * give undefined results (probably a crash), since p_iterator isn't
 * filled correctly.
 *
 * @param p_ht the hash table to iterate through.
 *
 * @param p_iterator the iterator to use.
 *
 * @param pp_key a pointer to the pointer of the key (NULL if none).
 *
 * @return a pointer to the next entry in the table or NULL if there
 * are no more entries in the table.
 *
 * @see ght_first()
 */
void *ght_next(ght_hash_table_t *p_ht, ght_iterator_t *p_iterator, void **pp_key);

/**
 * Rehash the hash table.
 *
 * Rehashing will change the size of the hash table, retaining all
 * elements. This is very costly and should be avoided unless really
 * needed. If <TT>GHT_AUTOMATIC_REHASH</TT> is specified in the flag
 * parameter when ght_create() is called, the hash table is
 * automatically rehashed when the number of stored elements exceeds
 * two times the number of buckets in the table (making calls to this
 * function unessessary).
 *
 * @param p_ht the hash table to rehash.
 * @param i_size the new size of the table.
 *
 * @see ght_create()
 */
void ght_rehash(ght_hash_table_t *p_ht, uint i_size);

/**
 * Free the hash table. ght_finalize() should typically be called
 * at the end of the program. Note that only the metadata and the keys
 * of the table is freed, not the entries. If you want to free the
 * entries when removing the table, the entries will have to be
 * manually freed before ght_finalize() is called like:
 *
 * <PRE>
 * ght_iterator_t iterator;
 * void *p_key;
 * void *p_e;
 *
 * for(p_e = ght_first(p_table, &iterator, &p_key); p_e; p_e = ght_next(p_table, &iterator, &p_key))
 *   {
 *     free(p_e);
 *   }
 *
 * ght_finalize(p_table);
 * </PRE>
 *
 * @param p_ht the table to remove.
 */
void ght_finalize(ght_hash_table_t *p_ht);

/* exported hash functions */

/**
 * One-at-a-time-hash. One-at-a-time-hash is a good hash function, and
 * is the default when ght_create() is called with NULL as the
 * fn_hash parameter. This was found in a DrDobbs article, see
 * http://burtleburtle.net/bob/hash/doobs.html
 *
 * @warning Don't call this function directly, it is only meant to be
 * used as a callback for the hash table.
 *
 * @see ght_fn_hash_t
 * @see ght_rotating_hash(), ght_crc_hash()
 */
uint ght_one_at_a_time_hash(ght_hash_key_t *p_key);

/**
 * Rotating hash. Not so good hash function. This was found in a
 * DrDobbs article, see http://burtleburtle.net/bob/hash/doobs.html
 *
 * @warning Don't call this function directly, it is only meant to be
 * used as a callback for the hash table.
 *
 * @see ght_fn_hash_t
 * @see ght_one_at_a_time_hash(), ght_crc_hash()
 */
uint ght_rotating_hash(ght_hash_key_t *p_key);

/**
 * CRC32 hash. CRC32 hash is a good hash function. This came from Dru
 * Lemley <spambait@lemley.net>.
 *
 * @warning Don't call this function directly, it is only meant to be
 * used as a callback for the hash table.
 *
 * @see ght_fn_hash_t
 * @see ght_one_at_a_time_hash(), ght_rotating_hash()
 */
uint ght_crc_hash(ght_hash_key_t *p_key);

/* Description:	Header file for doubly linked list routines.
*/

/*---------------------- Macros and type definitions ----------------------*/

typedef struct PS_DLST_BUCKET {
	struct PS_DLST_BUCKET	*next;
	struct PS_DLST_BUCKET	*prev;
	} PS_DLST_BUCKET;

/* necessary for AIX 4.2.x */

#ifdef hz
#undef hz
#endif
typedef struct dlist_ DLIST;
struct dlist_ {
	int			count;			/* Number of elements currently in list	*/
	PS_DLST_BUCKET	*head;			/* Pointer to head element of list		*/
	PS_DLST_BUCKET	*z;				/* Pointer to last node of list			*/
	PS_DLST_BUCKET	hz[2];			/* Space for head and z nodes			*/
	void  *(*malloc)(PSDoc *ps, ulong size, const char *caller);
	void  *(*realloc)(PSDoc *ps, void *mem, ulong size, const char *caller);
	void   (*free)(PSDoc *ps, void *mem);
	};

/* Return a pointer to the user space given the address of the header of
 * a node.
 */

#define	PS_DLST_USERSPACE(h)	((void*)((PS_DLST_BUCKET*)(h) + 1))

/* Return a pointer to the header of a node, given the address of the
 * user space.
 */

#define	PS_DLST_HEADER(n)		((PS_DLST_BUCKET*)(n) - 1)

/* Return a pointer to the user space of the list's head node. This user
 * space does not actually exist, but it is useful to be able to address
 * it to enable insertion at the start of the list.
 */

#define	PS_DLST_HEAD(l)		PS_DLST_USERSPACE((l)->head)

/* Return a pointer to the user space of the last node in list.	*/

#define	PS_DLST_TAIL(l)		PS_DLST_USERSPACE((l)->z->prev)

/* Determine if a list is empty
 */

#define	PS_DLST_EMPTY(l)		((l)->count == 0)

/*-------------------------- Function Prototypes --------------------------*/


void *dlst_newnode(DLIST *l, int size);
void dlst_freenode(DLIST *l, void *node);
DLIST *dlst_init(void* (*allocproc)(PSDoc *ps, ulong size, const char *caller), void* (*reallocproc)(PSDoc *ps, void *mem, ulong size, const char *caller), void  (*freeproc)(PSDoc *ps, void *mem));
void dlst_kill(DLIST *l,void (*freeNode)(DLIST *l, void *node));
void dlst_insertafter(DLIST *l,void *node,void *after);
void *dlst_deletenext(DLIST *l,void *node);
void *dlst_first(DLIST *l);
void *dlst_last(DLIST *l);
void *dlst_next(void *prev);
void *dlst_prev(void *next);
void dlst_mergesort(DLIST *l,int (*cmp_func)(void*,void*));

struct str_buffer_ {
	char *buffer;
	ulong cur;
	ulong size;
};

typedef struct str_buffer_ STRBUFFER;

STRBUFFER *str_buffer_new(PSDoc *psdoc, ulong size);
void str_buffer_delete(PSDoc *psdoc, STRBUFFER *sb);
ulong str_buffer_print(PSDoc *psdoc, STRBUFFER *sb, const char *fmt, ...);
ulong str_buffer_write(PSDoc *psdoc, STRBUFFER *sb, const char *data, ulong size);
const char *str_buffer_get(PSDoc *psdoc, STRBUFFER *sb);
ulong str_buffer_len(PSDoc *psdoc, STRBUFFER *sb);
void str_buffer_clear(PSDoc *psdoc, STRBUFFER *sb);
/* LibHnj is dual licensed under LGPL and MPL. Boilerplate for both
 * licenses follows.
 */

typedef struct _HyphenDict HyphenDict;
typedef struct _HyphenState HyphenState;
typedef struct _HyphenTrans HyphenTrans;
#define MAX_CHARS 256
#define MAX_NAME 20

struct _HyphenDict {
  int num_states;
  char cset[MAX_NAME];
  HyphenState *states;
};

struct _HyphenState {
  char *match;
  int fallback_state;
  int num_trans;
  HyphenTrans *trans;
};

struct _HyphenTrans {
  char ch;
  int new_state;
};

HyphenDict *hnj_hyphen_load (const char *fn);
void hnj_hyphen_free (HyphenDict *dict);
int hnj_hyphen_hyphenate (HyphenDict *dict,
			   const char *word, int word_size,
			   char *hyphens);


#define _(a) a

#define max(a,b) ((a)>(b) ? (a) : (b))
#define min(a,b) ((a)<(b) ? (a) : (b))

#define PS_BORDER_UNSET  0
#define PS_BORDER_SOLID  1
#define PS_BORDER_DASHED 2

/* horizontal modes for PS_show_boxed() */
#define PS_TEXT_HMODE_JUSTIFY 1
#define PS_TEXT_HMODE_LEFT 2
#define PS_TEXT_HMODE_RIGHT 3
#define PS_TEXT_HMODE_CENTER 4
#define PS_TEXT_HMODE_FULLJUSTIFY 5

typedef struct encoding_ ENCODING;

typedef struct lig_ LIG;

typedef struct kern_ KERN;

typedef struct adobeptr_ ADOBEPTR;

typedef struct pcc_ PCC;

typedef struct adobeinfo_ ADOBEINFO;

typedef struct adobefontmetric_ ADOBEFONTMETRIC;

typedef union _optvalue_value {
	long lval;      //long value 
	double dval;    //double value
	struct {
		char *val;
		int len;
	} str;
	ght_hash_table_t *ht;        // hash table value
} optvalue_value;

typedef struct _optval_struct optval;

struct _optval_struct {
	optvalue_value value;
	char type;
};

struct lig_ {
   struct lig_ *next ;
   char *succ, *sub ;
   short op, boundleft ;
};

struct encoding_ {
	char *name ;
	char *vec[256] ;
};

struct kern_ {
   struct kern_ *next ;
   char *succ ;
   int delta ;
};

struct adobeptr_ {
	 struct adobeptr_ *next;
	 struct adobeinfo_ *ch;
};

struct pcc_ {
   struct pcc_ *next ;
   char * partname ;
   int xoffset, yoffset ;
};

struct adobeinfo_ {
   int adobenum, texnum, width ;
   char *adobename ;
   int llx, lly, urx, ury ;
   LIG *ligs ;
   KERN *kerns ;
   ADOBEPTR *kern_equivs ;
   PCC *pccs ;
	 int lkern, rkern;  /* Kerning on left and right margin */
};

struct adobefontmetric_ {
	ght_hash_table_t *gadobechars;
	FILE *afmin;        /* File for encoding */
	char *fontname; // = "Unknown" ;
	char *codingscheme; // = "Unspecified" ;
	ght_hash_table_t *fontenc;
#ifdef VMCMS
	char *ebfontname ;
	char *ebcodingscheme ;
#endif
	float italicangle; // = 0.0 ;
	float underlineposition;
	float underlinethickness;
	float ascender;
	float descender;
	char fixedpitch ;
	char makevpl ;
	char pedantic ;
	int xheight; // = 400 ;
	int fontspace ;
	int bc, ec ;
	long cksum ;
	float efactor; // = 1.0;
	float slant; // = 0.0 ;
	float capheight; // = 0.8 ;
	char *efactorparam, *slantparam ;
	double newslant ;
};

typedef struct PSColor_ PSColor;

typedef struct PSImage_ PSImage;

struct PSImage_ {
	PSDoc *psdoc; // Doc for which this image was created
	char *name;   // currently only used for templates
	char *type;
	char *data;
	long length;
	int width;
	int height;
	int components;
	int bpc;
	int colorspace;
	ps_bool ismask;
	PSColor *palette;
	int numcolors;
	PSImage *imagemask; // Use other image as mask for this image
};

typedef struct PSFont_ PSFont;

struct PSFont_ {
	PSDoc *psdoc; // Doc for which this font was created
	char *name;   // currently not used
	float size;
	int wordspace;
	char *encoding;
	ADOBEFONTMETRIC *metrics;
};

typedef struct PSPattern_ PSPattern;

struct PSPattern_ {
	PSDoc *psdoc; // Doc for which this font was created
	char *name;
	int painttype;
	int shading;
	float width;
	float height;
	float xstep;
	float ystep;
};

#define PS_COLORSPACE_GRAY    1
#define PS_COLORSPACE_RGB     2
#define PS_COLORSPACE_CMYK    3
#define PS_COLORSPACE_SPOT    4
#define PS_COLORSPACE_PATTERN 5
#define PS_COLORSPACE_INDEXED 6

#define PS_COLORTYPE_FILL   1
#define PS_COLORTYPE_STROKE 2

typedef struct PSSpotColor_ PSSpotColor;

struct PSSpotColor_ {
	PSDoc *psdoc; // Doc for which this font was created
	char *name;
	int colorspace;
	float c1;
	float c2;
	float c3;
	float c4;
};

struct PSColor_ {
	int colorspace;
	int prevcolorspace;  // The last colorspace used for pattern of type 1
	int pattern;         // The pattern id
	float c1;
	float c2;
	float c3;
	float c4;
};

typedef struct PSShading_ PSShading;

struct PSShading_ {
	char *name;
	int type;
	float x0;
	float y0;
	float x1;
	float y1;
	float r0;
	float r1;
	float N;
	ps_bool extend0;
	ps_bool extend1;
	ps_bool antialias;
	PSColor startcolor;
	PSColor endcolor;
};

typedef struct PSGState_ PSGState;

struct PSGState_ {
	char *name;
	/* x, y for drawing */
	float x;
	float y;

	/* current fill color */
	PSColor fillcolor;
	ps_bool fillcolorinvalid;   /* set to ps_true if fill color has changed */

	/* current stroke color */
	PSColor strokecolor;
	ps_bool strokecolorinvalid; /* set to ps_true if stroke color has changed */

	ght_hash_table_t *opthash;
};

typedef struct PSTState_ PSTState;

struct PSTState_ {
	/* x, y for drawing text */
	float tx;
	float ty;
	/* x, y for continue text */
	float cx;
	float cy;
};

typedef struct value_ PS_VALUE;
struct value_ {
   char *name;
   float value;
};

typedef struct resource_ PS_PARAMETER;
typedef struct resource_ PS_RESOURCE;
struct resource_ {
   char *name;
   char *value;
};

typedef struct categorie_ PS_CATEGORY;
struct categorie_ {
   char *name;
   DLIST *resources;
};

typedef struct bookmark_ PS_BOOKMARK;
struct bookmark_ {
	int id;
	char *text;
	int open;
	int page;
	DLIST *children;
};

#define PS_MAX_GSTATE_LEVELS 10
#define PS_MAX_TSTATE_LEVELS 10

#define MAX_SCOPES       20  // maximum number of scopes on the stack
#define PS_SCOPE_NONE     0
#define PS_SCOPE_OBJECT   1
#define PS_SCOPE_DOCUMENT 2
#define PS_SCOPE_PAGE     4
#define PS_SCOPE_PATH     8
#define PS_SCOPE_TEMPLATE 16
#define PS_SCOPE_PATTERN  32
#define PS_SCOPE_PROLOG   64
#define PS_SCOPE_FONT     128
#define PS_SCOPE_GLYPH    256

#define LINEBUFLEN    1024

struct PSDoc_ {
	/* Document Information */
	char  *Keywords;
	char  *Subject;
	char  *Title;
	char  *Creator;
	char  *Author;
	char  *BoundingBox;
	char  *Orientation;

	int copies;

	STRBUFFER *sb;
	FILE *fp;
	ps_bool closefp;
	ps_bool headerwritten;
	ps_bool commentswritten;
	ps_bool beginprologwritten;
	ps_bool endprologwritten;
	ps_bool setupwritten;

	/* Creation date */
	char *CreationDate;

	/* Input encoding */
	ENCODING *inputenc;

	/* Hyphenation dictionary */
	HyphenDict *hdict;
	char *hdictfilename;

	/* The current font */
	PSFont *font;

	/* The current pattern */
	PSPattern *pattern;

	DLIST *categories;
	DLIST *parameters;
	DLIST *values;
	DLIST *bookmarks;	          /* list of first level bookmarks */
	int lastbookmarkid;         /* id of last bookmark */
	PS_BOOKMARK **bookmarkdict;  /* Bookmark lookup table */
	int bookmarkcnt;            /* Number of entries in lookup table */

	/* page stores the current page number.
	 * It is increased each time a page begins */
	uint page;
	int in_error;
	ps_bool warnings;          /* Whether warnings shall be output */

	/* The stack of scopes */
	int scopecount;
	int scopes[MAX_SCOPES];

	/* List of fonts, images, patterns and spotcolors used in this document */
	PSFont **fonts;
	int fontcnt;
	PSImage **images;
	int imagecnt;
	PSPattern **patterns;
	int patterncnt;
	PSShading **shadings;
	int shadingcnt;
	PSSpotColor **spotcolors;
	int spotcolorcnt;
	PSGState **gstates;
	int gstatecnt;

	/* text appearance */
	ps_bool underline;
	ps_bool overline;
	ps_bool strikeout;
	int textrendering;

	/* grafic states */
	int agstate;
	PSGState agstates[PS_MAX_GSTATE_LEVELS];
	int tstate;
	PSTState tstates[PS_MAX_TSTATE_LEVELS];

	/* misc */
	ps_bool page_open;   /* set to true when PS_begin_page() is called
												* reset to false in PS_end_page() */
	ps_bool doc_open;    /* set to true when document is opened and reset
												* to false in PS_close() */

	/* border of annotations */
	int border_style;
	float border_width;
	float border_red;
	float border_green;
	float border_blue;
	float border_black;
	float border_white;

	/* output function */
	ulong  (*writeproc)(PSDoc *p, void *data, ulong size);

	/* user data passed by PS_new2(). Can be retrieved with PS_get_opaque() */
	void *user_data;

	/* error handler function */
	void  (*errorhandler)(PSDoc *p, int level, const char* msg, void *data);

	/* Memory allocation functions */
	void  *(*malloc)(PSDoc *p, ulong size, const char *caller);
	void  *(*calloc)(PSDoc *p, ulong size, const char *caller);
	void  *(*realloc)(PSDoc *p, void *mem, ulong size, const char *caller);
	void   (*free)(PSDoc *p, void *mem);
};

/* ps_util.c */
void ps_write(PSDoc *p, const void *data, ulong size);
void ps_putc(PSDoc *p, char c);
void ps_puts(PSDoc *p, const char *s);
void ps_printf(PSDoc *p, const char *fmt, ...);
void* ps_ght_malloc(ulong size, void *data);
void ps_ght_free(void *ptr, void *data);
PS_RESOURCE **ps_get_resources(PSDoc *psdoc, const char *category, int *count);
char *ps_find_resource(PSDoc *psdoc, const char *category, const char *resource);
PS_RESOURCE * ps_add_resource(PSDoc *psdoc, const char *category, const char *resource, const char *filename, const char *prefix);
int ps_get_bool_parameter(PSDoc *psdoc, const char *name, int deflt);
float ps_get_word_spacing(PSDoc *psdoc, PSFont *psfont);
void ps_set_word_spacing(PSDoc *psdoc, PSFont *psfont, float value);
void ps_add_word_spacing(PSDoc *psdoc, PSFont *psfont, float value);
void ps_del_resources(PSDoc *psdoc);
void ps_del_parameters(PSDoc *psdoc);
void ps_del_values(PSDoc *psdoc);
void ps_del_bookmarks(PSDoc *psdoc, DLIST *bookmarks);
int ps_check_for_lig(PSDoc *psdoc, ADOBEFONTMETRIC *metrics, ADOBEINFO *ai, const char *text, char ligdischar, char **newadobename, int *offset);
ght_hash_table_t *ps_build_enc_hash(PSDoc *psdoc, ENCODING *enc);
ght_hash_table_t *ps_build_enc_from_font(PSDoc *psdoc, ADOBEFONTMETRIC *metrics);
ENCODING *ps_build_enc_vector(PSDoc *psdoc, ght_hash_table_t *hashvec);
void ps_list_fontenc(PSDoc *psdoc, ght_hash_table_t *hashvec);
void ps_free_enc_vector(PSDoc *psdoc, ENCODING *enc);
uchar ps_fontenc_code(PSDoc *psdoc, ght_hash_table_t *fontenc, char *adobename);
int ps_fontenc_has_glyph(PSDoc *psdoc, ght_hash_table_t *fontenc, char *adobename);
char *ps_inputenc_name(PSDoc *psdoc, uchar c);
void ps_enter_scope(PSDoc *psdoc, int scope);
void ps_leave_scope(PSDoc *psdoc, int scope);
int ps_current_scope(PSDoc *psdoc);
ps_bool ps_check_scope(PSDoc *psdoc, int scope);
FILE *ps_open_file_in_path(PSDoc *psdoc, const char *filename);
ght_hash_table_t *ps_parse_optlist(PSDoc *psdoc, const char *optstr);
int get_optlist_element_as_float(PSDoc *psdoc, ght_hash_table_t *opthash, const char *name, float *value);
int get_optlist_element_as_int(PSDoc *psdoc, ght_hash_table_t *opthash, const char *name, int *value);
int get_optlist_element_as_bool(PSDoc *psdoc, ght_hash_table_t *opthash, const char *name, ps_bool *value);
int get_optlist_element_as_string(PSDoc *psdoc, ght_hash_table_t *opthash, const char *name, char **value);
void ps_ascii85_encode(PSDoc *psdoc, char *data, ulong len);
void ps_asciihex_encode(PSDoc *psdoc, char *data, ulong len);

/* ps_afm.c */
int calculatekern(ADOBEINFO *ai, ADOBEINFO *succ);
ADOBEFONTMETRIC *readadobe(PSDoc *psdoc, const char *filename);
ADOBEINFO *gfindadobe(ght_hash_table_t *adobechars, const char *p);
int readprotusion(PSDoc *psdoc, PSFont *psfont, const char *filename);
int readencoding(PSDoc *psdoc, ADOBEFONTMETRIC *metrics, const char *enc);
void addkern(PSDoc *psdoc, ADOBEINFO *ai, ADOBEINFO *succ, int kerning);
void addligature(PSDoc *psdoc, ADOBEINFO *ai, ADOBEINFO *succ, ADOBEINFO *sub);


#endif
ulong ps_strlen(const char *str);
char * ps_strdup(PSDoc *p, const char *str);
void * ps_calloc(PSDoc *p, ulong size, const char *caller);

void * _ps_malloc(PSDoc *p, ulong size, const char *caller);
void * _ps_realloc(PSDoc *p, void *mem, ulong size, const char *caller);
void _ps_free(PSDoc *p, void *mem);
void _ps_errorhandler(PSDoc *p, int error, const char *str, void *data);
void ps_error(PSDoc *p, int type, const char *fmt, ...);
extern ENCODING fontencoding[];
extern ENCODING inputencoding[];

ENCODING *ps_get_inputencoding(const char *name);
/*
 * version.h : compile-time version informations for the pslib.
 */


/*
 * use those to be sure nothing nasty will happen if
 * your library and includes mismatch
 */
#define LIBPS_DOTTED_VERSION "0.4.1"
#define LIBPS_MAJOR_VERSION 0
#define LIBPS_MINOR_VERSION 4
#define LIBPS_MICRO_VERSION 1

/*
 * Whether Debugging module is configured in
 */
//#define LIBPS_DEBUG_ENABLED
#define LIBPS_DEBUG_DISABLED

int eps_bbox(char *eps, double *llx, double *lly, double *urx, double *ury);
int pat_save(PSDoc *psdoc, char *epsf, char *name);
